#include "osd_gfx.h"

BITMAP* OSD_MESSAGE_SPR = NULL;

int blit_x,blit_y;
// where must we blit the screen buffer on screen

void osd_gfx_set_message(char* mess)
{

 if (OSD_MESSAGE_SPR)
   destroy_bitmap(OSD_MESSAGE_SPR);

 OSD_MESSAGE_SPR=create_bitmap(text_length(font,mess)+1,text_height(font)+1);
 clear(OSD_MESSAGE_SPR);
 textout(OSD_MESSAGE_SPR,font,mess,1,1,3);
 textout(OSD_MESSAGE_SPR,font,mess,0,0,255);
 return;

 }

/*****************************************************************************

    Function:  osd_gfx_init_normal_mode

    Description: initialize the classic 256*224 video mode for normal video_driver
    Parameters: none
    Return: 0 on error
                 1 on success

*****************************************************************************/
int osd_gfx_init_normal_mode()
{
  if (vmode==5)
    return !osd_gfx_set_hugo_mode(GFX_AUTODETECT,800,600);

  if (io.screen_w==40*8)
    {
      if (!osd_gfx_set_hugo_mode(GFX_AUTODETECT,320,240))
        return 1;
    }

  if (io.screen_w>40*8)
    {
      if (!osd_gfx_set_hugo_mode(GFX_AUTODETECT,360,240))
        return 1;
    }

  if ((vmode==0) && (!osd_gfx_set_hugo_mode(GFX_VGA,256,224)));
   else
  if ((vmode<=1) && (!osd_gfx_set_hugo_mode(GFX_AUTODETECT,256,240)));
   else
  if ((vmode<=2) && (!osd_gfx_set_hugo_mode(GFX_AUTODETECT,256,256)));
   else
  if ((vmode<=3) && (!osd_gfx_set_hugo_mode(GFX_AUTODETECT,320,240)));
   else
  if ((vmode<=4) && (!osd_gfx_set_hugo_mode(GFX_AUTODETECT,320,200)));
   else
          return 0;

 return 1;
 }



UInt16 osd_gfx_savepict()
  {
          BITMAP *bmp;
          PALETTE pal;
          char* final="PICT0000.PCX";
          short unsigned tmp=0;

          while ((tmp!=0xFFFF) && (exists(final)))
              sprintf(final,"PICT%04X.PCX",++tmp);
          if (tmp==0xFFFF)
            return tmp;

          get_palette(pal);
          /*  TEST, doesn't have any effect
            Log("pal[255]=%d,%d,%d\n",pal[255].r,pal[255].g,pal[255].b);
            pal[255].r = pal[255].g = pal[255].b = 255;
          */


          if ((use_eagle) || (use_scanline))
            bmp = create_sub_bitmap(screen,
                                    blit_x,
                                    blit_y,
                                    io.screen_w * 2,
                                    io.screen_h * 2);
 	  else
            bmp = create_sub_bitmap(screen,
                                    blit_x,
                                    blit_y,
                                    io.screen_w,
                                    io.screen_h);

          save_bitmap(final, bmp, pal);

          destroy_bitmap(bmp);

          return tmp;
   }

/*****************************************************************************

    Function:  osd_gfx_set_hugo_mode

    Description: change the video mode
    Parameters: mode : mode of video screen
                width, height : minimum size of screen required
    Return: 0 on success
                 1 on error

*****************************************************************************/
SInt32 osd_gfx_set_hugo_mode(SInt32 mode,SInt32 width,SInt32 height)
{

 if (!set_gfx_mode(mode,width,height,0,0))
            {
             Log("Changing video mode to %dx%d\nPCE screen size is %dx%d\n",
                 width,
                 height,
                 io.screen_w,
                 io.screen_h);
             vwidth=width;
             vheight=height;

             blit_x=(width-io.screen_w)/2;
             blit_y=(height-io.screen_h)/2;

             screen_blit_x=(WIDTH-io.screen_w)/2;
             screen_blit_y=(224-io.screen_h)/2;

             Log("Now blit_x = %d\nblit_y = %d\nscreen_blit_x = %d\nscreen_blit_y = %d\n\n",
                 blit_x,
                 blit_y,
                 screen_blit_x,
                 screen_blit_y);

             SetPalette();
             return 0;
             }
 return 1;
 }

void osd_gfx_set_color(UChar index,
                       UChar r,
                       UChar g,
                       UChar b)
{

 RGB R;
 R.r=r;
 R.g=g;
 R.b=b;

 set_color(index, &R);

 }
